/*! 
  @file rx_levelset3d.h
	
  @brief 3xZbg@
		  - t̍\zƑx̊O}
		  - Ql : http://code.google.com/p/levelset2d/

  @author Makoto Fujisawa
  @date 2013-10
*/


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
// CW
#include <cmath>

#include <iostream>
#include <iomanip>
#include <fstream>

// STL
#include <vector>
#include <string>
#include <queue>

#include "rx_utility.h"


//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
using namespace std;

#ifndef RXREAL
#define RXREAL float
#endif


//-----------------------------------------------------------------------------
//! rxLevelSet3DNX - 2xZbg@
//-----------------------------------------------------------------------------
class rxLevelSet3D
{
protected:
	enum{
		FMM_ACCEPTED,	//!< lm
		FMM_TENTATIVE,	//!< 
		FMM_NONE,		//!< 
	};

	struct rxGrid
	{
		RXREAL dist;	//!< l
		char state;		//!< 
		Vec3 pos;		//!< ŋߖT\ʈʒu
		int i, j, k;		//!< ObhCfbNX

		rxGrid()
		{
			dist = 1.0;
			state = FMM_NONE;
			i = j = k = -1;
		}
	};
	rxGrid *m_pGrids;			//!< A֐
	RXREAL *m_pGrad[3];			//!< A֐̌z

	int m_iNx, m_iNy, m_iNz;	//!< Obh
	RXREAL m_fH;				//!< Obh

public:
	char m_cShowGrid;
	char m_cShowDist;
	char m_cShowRegion;
	
public:
	//! ObhԂ̋lrq֐
	struct RxGridComp{
		bool operator()(rxGrid *a, rxGrid *b)
		{
			return fabs(a->dist) > fabs(b->dist); 
		}
	};
	// lɊÂq֐rɗpDL[`
	typedef priority_queue<rxGrid*, vector<rxGrid*>, RxGridComp> GridQueue;


public:
	//! ftHgRXgN^
	rxLevelSet3D();

	//! fXgN^
	~rxLevelSet3D();

public:
	//! 
	void Init(int nx, int ny, int nz, RXREAL h);
	void Set(RXREAL (*func)(RXREAL, RXREAL, RXREAL, void*), void* x, RXREAL tol, bool app = false);
	void Set(RXREAL *f, RXREAL tol, bool app = false);
	void Get(RXREAL *f);

	//! t̍ď
	void Reinitialize(RXREAL tol);

	//! tB[hl̊O}
	void Extrapolate(RXREAL *f);


protected:
	inline int ix(int i, int j, int k){ return (i+(j+k*m_iNy)*m_iNx); }
	inline void copy(RXREAL *src, RXREAL *dst, int n){ for(int i = 0; i < n; ++i) dst[i] = src[i]; }

	//! Fast Marching Methodɂ鋗č\z
	void fastMarching(RXREAL tol);

	//! ߖTmObhgXV
	bool updateDistance(int i, int j, int k, Vec3 pos, RXREAL &dist);

	//! XLCT
	void scanline(int d, int nx, int ny, int nz);

	//! _vZ
	inline void intersect(Vec3 x1, Vec3 x2, Vec3 &x)
	{
		double t = dot(x-x1, x2-x1)/dot(x2-x1, x2-x1);
		t = RX_MIN(1.0, RX_MAX(0.0, t));
		x = x1+t*(x2-x1);
	}

	//! fobOp
	void dump(int k);
};
