/*!
  @file glmain.cpp
	
  @brief SPH@ɂt̃V~[V
 
  @author Makoto Fujisawa
  @date   2013-10
*/

#pragma comment(lib, "glew32.lib")

//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include <GL/glew.h>

#include "rx_common.h"

#include "rx_bitmap.h"

#include "rx_trackball.h"
#include "rx_atom_ini.h"

#include "rx_sph.h"
#include "rx_config.h"

#include "rx_mc.h"
#include "rx_shaders.h"


//-----------------------------------------------------------------------------
// `/萔
//-----------------------------------------------------------------------------
const string RX_PROGRAM_NAME = "rx_sph";

const GLfloat RX_FOV = 45.0f;

//! etO
enum{
	RXD_BOUNDARY	= (1 << 0),		//!< V~[VԋE`
	RXD_SURF        = (1 << 1),		//!< t̕\ʃbV`
	RXD_SURF_EDGE   = (1 << 2),		//!< t̕\ʃbṼGbW`
	RXD_PARTICLE    = (1 << 3),		//!< p[eBN`
	RXD_SOLID		= (1 << 4),		//!< ő̃IuWFNg`
	RXD_CELLS		= (1 << 5),		//!< ߖTTpObh̕`
};

#define RXSPH rxSPH


//-----------------------------------------------------------------------------
// O[oϐ
//-----------------------------------------------------------------------------
bool g_bIdle = false;

// }EX
int g_iWinW = 720;				//!< `EBhE̕
int g_iWinH = 720;				//!< `EBhE̍
int g_iWinX = 100;				//!< `EBhEʒux
int g_iWinY = 100;				//!< `EBhEʒuy

int g_iWinPos[2] = {100, 100};	//!< EBhEʒu(tXN[ؑ֎̋Lp)
int g_iWinSize[2] = {640, 640};	//!< EBhETCY(tXN[ؑ֎̋Lp)
bool g_bFullScreen = false;		//!< tXN[\

//! `tO
int g_iDraw = RXD_BOUNDARY | RXD_PARTICLE | RXD_SOLID;

// 摜o
int g_iSaveImageSpacing = -1;	//!< 摜ۑԊu(=-1ȂۑȂ)
bool g_bSavedImage = false;		//!< dۑh~ptO

//! ݒt@C
rxINI *g_pINI = NULL;

//! V[ݒ
rxSceneConfig g_Scene;
int g_iCurrentSceneIdx = 0;

//! ̃\o
rxParticleSystemBase *g_pSolver = 0;	//!< SPH

//! vZXebv
int g_iStep = 0;

//! _ړpgbN{[
rxTrackball g_tbView;

//! \ʃbV
rxPolygons g_Poly;

// V~[Vݒ(ۂ̒l͐ݒt@C*.cfgǂݍ܂)
RXREAL g_fDt = 0.01;		//!< V~[VԃXebv
int g_iMeshN = 64;			//!< MC@̃Obh
RXREAL g_fMeshThr = 400.0;	//!< \ʂl

// `ݒ
int g_iColorType = rxParticleSystemBase::RX_RAMP;	//!< p[eBN`掞̐F
rxGLSL g_glslPointSprite;							//!< GLSLg`


//-----------------------------------------------------------------------------
// ֐vg^Cv錾
//-----------------------------------------------------------------------------
void OnExitApp(int id = -1);

void Idle(void);
void CleanGL(void);

void CreateMesh(void);


//-----------------------------------------------------------------------------
// AvP[V
//-----------------------------------------------------------------------------
/*!
 * ACh֐ON/OFF
 * @param[in] on 1ON, 0OFF, -1ON/OFF؂ւ
 */
void SwitchIdle(int on = -1)
{
	g_bIdle = (on == -1) ? !g_bIdle : (on ? true : false);
	glutIdleFunc((g_bIdle ? Idle : 0));
	cout << "idle " << (g_bIdle ? "on" : "off") << endl;
}

/*!
 * tXN[/EBhE\̐؂ւ
 */
void SwitchFullScreen(void)
{
	if(g_bFullScreen){
		glutPositionWindow(g_iWinPos[0], g_iWinPos[1]);
		glutReshapeWindow(g_iWinSize[0], g_iWinSize[1]);
		g_bFullScreen = false;
	}
	else{
		g_iWinPos[0] = glutGet(GLUT_WINDOW_X);
		g_iWinPos[1] = glutGet(GLUT_WINDOW_Y);
		g_iWinSize[0] = glutGet(GLUT_WINDOW_WIDTH);
		g_iWinSize[1] = glutGet(GLUT_WINDOW_HEIGHT);

		glutFullScreen();
		g_bFullScreen = true;
	}
}

/*!
 * AvP[VI  Quit{^̃Cxgnh
 * @param[in] id {^̃CxgID
 */
void OnExitApp(int id)
{
	CleanGL();

	exit(1);
}

/*!
 * ݒt@Cǂݍ
 * @param[in] fn ݒt@C(gq)
 */
void ReadConfig(const string &fn)
{
	// AvP[VǗݒt@C
	g_pINI = new rxINI();

	g_pINI->Set("window", "width",  &g_iWinW, 720);
	g_pINI->Set("window", "height", &g_iWinH, 720);
	g_pINI->Set("window", "pos_x",  &g_iWinX, 100);
	g_pINI->Set("window", "pos_y",  &g_iWinY, 100);
	g_pINI->Set("scene", "idx", &g_iCurrentSceneIdx, 0);

	if(!(g_pINI->Load(fn+".ini"))){
		RXCOUT << "Failed opening the " << fn << ".ini file!" << endl;
	}
	
}

/*!
 * ݒt@C
 * @param[in] fn ݒt@C(gq)
 */
void WriteConfig(const string &fn)
{
	g_iWinX = glutGet(GLUT_WINDOW_X);
	g_iWinY = glutGet(GLUT_WINDOW_Y);
	g_iCurrentSceneIdx = g_Scene.GetCurrentSceneIdx();

	if(g_pINI->Save(fn+".ini")){
		RXCOUT << "save : " << fn << ".ini" << endl;
	}
}

/*!
 * EBhE^Cgݒ
 */
void SetTitle(void)
{
	stringstream ss;
	ss << "step " << g_iStep;
	ss << " - scene " << g_iCurrentSceneIdx+1;
	if(g_pSolver) ss << " - particle " << g_pSolver->GetNumParticles();
	glutSetWindowTitle(ss.str().c_str());
}

/*!
 * ݂̉ʕ`摜t@CƂĕۑ
 * @param[in] fn t@CpX
 */
void SaveDisplay(const string &fn)
{
	int w_ = g_iWinW;
	int h_ = g_iWinH;
	int c_ = 4;

	unsigned char* data = new unsigned char[w_*h_*c_];

	glReadPixels(0, 0, w_, h_, GL_RGBA, GL_UNSIGNED_BYTE, data);

	// ㉺]
	int stride = w_*c_;
	for(int j = 0; j < h_/2; ++j){
		for(int i = 0; i < stride; ++i){
			unsigned char tmp = data[j*stride+i];
			data[j*stride+i] = data[(h_-j-1)*stride+i];
			data[(h_-j-1)*stride+i] = tmp;
		}
	}

	string ext = GetExtension(fn);
	if(ext == "bmp"){
		WriteBitmapFile(fn, data, w_, h_, c_, RX_BMP_WINDOWS_V3);
		RXCOUT << "saved the screen image to " << fn << endl;
	}

	delete [] data;
}


//-----------------------------------------------------------------------------
// ̃V~[V
//-----------------------------------------------------------------------------
/*!
 * ̃V~[^̏
 */
void InitSim(void)
{
	g_Scene.ReadSceneFiles();					// V[t@C̓ǂݎ
	g_Scene.SetCurrentScene(g_iCurrentSceneIdx);
	if(g_Scene.LoadSpaceFromFile()){
		// V[t@CV~[Vԏ񂪓ǂݍ߂\o\z
		if(g_pSolver) delete g_pSolver;
		g_pSolver = new RXSPH(true);

		// V~[VԂ̍\z
		rxEnviroment env = g_Scene.GetEnv();
		((RXSPH*)g_pSolver)->Initialize(env);
		g_fDt = env.dt;
		g_iMeshN = env.mesh_max_n;
		g_fMeshThr = env.mesh_thr;

		// p[eBN`̂߂̃J[^Cv̐ݒ
		g_pSolver->SetColorType(g_iColorType);
		g_pSolver->SetColorVBO();

		// \õV[ݒZbgāCt@CVɃV[擾
		g_pSolver->Reset(rxParticleSystemBase::RX_CONFIG_NONE);
		g_Scene.Set(g_pSolver);
		g_Scene.LoadSceneFromFile();

		// XebvƏt̕\ʃbV쐬
		g_iStep = 0;
		CreateMesh();

		SetTitle();
		glutPostRedisplay();
	}
	else{
		RXCOUT << "there is no scene file." << endl;
		exit(0);
	}
}

/*!
 * t̕\ʃbV
 */
void CreateMesh(void)
{
	if(!g_pSolver) return;

	// p[eBNߖTTpZɊi[
	g_pSolver->SetParticlesToCell();

	Vec3 minp = g_pSolver->GetMin();
	Vec3 dim  = g_pSolver->GetDim();

	int n[3] = {64, 64, 64};
	n[0] = n[1] = n[2] = g_iMeshN;
	double h = RX_MIN3(dim[0], dim[1], dim[2])/g_iMeshN;

	// |S
	if(!g_Poly.vertices.empty()){
		g_Poly.vertices.clear();
		g_Poly.normals.clear();
		g_Poly.faces.clear();
		g_Poly.materials.clear();
	}

	// Marching CubesŃbV
	rxMCMeshCPU mc;
	mc.CreateMesh(RXSPH::GetImplicit_s, g_pSolver, minp, h, n, g_fMeshThr, 
				  g_Poly.vertices, g_Poly.normals, g_Poly.faces);

	// ^{[ƉA֐ľzɂȂĂ܂̂Ŗ@𔽓]Ă
	vector<Vec3>::iterator itr = g_Poly.normals.begin();
	for(; itr != g_Poly.normals.end(); ++itr){
		*itr *= -1.0;
	}
}

/*!
 * p[eBN|CgXvCgŕ`
 *  - |CgXvCg̓eNX`𒣂_(GL_POINT)
 *  - VBOΗp
 * @param[in] vbo p[eBNʒui[VBO
 * @param[in] n p[eBN
 * @param[in] color_vbo p[eBN̐Fi[VBO
 * @param[in] data p[eBNW(zXgCvbo0̎Ɏgp)
 * @param[in] prad p[eBNa
 */
void DrawParticlePoints(unsigned int vbo, int n, unsigned int color_vbo, RXREAL *data, RXREAL prad)
{
	float pscale = g_iWinH/tanf(RX_FOV*0.5f*(float)RX_PI/180.0f);

	// |CgXvCg`ON
	glEnable(GL_POINT_SPRITE);

	// |CgXvCgɃeNX`Wݒ肷悤ɊύX
	glTexEnvi(GL_POINT_SPRITE, GL_COORD_REPLACE, GL_TRUE);
	
	// GLSLVF[_ł̃|CgTCYύXL
	glEnable(GL_VERTEX_PROGRAM_POINT_SIZE);

	glDepthMask(GL_TRUE);
	glEnable(GL_DEPTH_TEST);
	
	// |CgXvCĝ߂GLSLVF[_L
	glUseProgram(g_glslPointSprite.Prog);
	glUniform1f( glGetUniformLocation(g_glslPointSprite.Prog, "prad"), prad );
	glUniform1f( glGetUniformLocation(g_glslPointSprite.Prog, "pscale"), pscale );

	if(!vbo){
		// VBOݒ肳ĂȂꍇ͒PglBegin-glEndŕ`
		glBegin(GL_POINTS);
		int k = 0;
		for(int i = 0; i < n; ++i){
			glVertex3d(data[k], data[k+1], data[k+2]);
			k += 4;
		}
		glEnd();
	}
	else{
		// VBOݒ肳Ă炻gĕ`
		glBindBuffer(GL_ARRAY_BUFFER, vbo);
		glEnableClientState(GL_VERTEX_ARRAY);
		glVertexPointer(4, (sizeof(RXREAL) == 4 ? GL_FLOAT : GL_DOUBLE), 0, 0);

		if(color_vbo){
			// Fŵ߂VBO
			glBindBufferARB(GL_ARRAY_BUFFER_ARB, color_vbo);
			glColorPointer(4, (sizeof(RXREAL) == 4 ? GL_FLOAT : GL_DOUBLE), 0, 0);
			glEnableClientState(GL_COLOR_ARRAY);
		}

		glDrawArrays(GL_POINTS, 0, n);

		glDisableClientState(GL_VERTEX_ARRAY); 
		glDisableClientState(GL_COLOR_ARRAY); 
		glBindBuffer(GL_ARRAY_BUFFER, 0);
	}

	glUseProgram(0);
	glDisable(GL_POINT_SPRITE);
}


//------------------------------------------------------------------
// OpenGLLoXp̃Cxgnh
//------------------------------------------------------------------
/*!
 * ĕ`Cxg֐
 */
void Display(void)
{
	// t[obt@ƃfvXobt@NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glDisable(GL_CULL_FACE);
	glDisable(GL_LIGHTING);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	glPushMatrix();

	// }EXɂ]Esړ̓Kp
	g_tbView.Apply();
	
	// V~[V擾
	int pnum = g_pSolver->GetNumParticles();
	Vec3 minp = g_pSolver->GetMin();
	Vec3 maxp = g_pSolver->GetMax();

	// E
	if(g_iDraw & RXD_BOUNDARY){
		glDisable(GL_LIGHTING);
		glColor3d(0.4, 1.0, 0.4);
		glLineWidth(2.0);
		DrawWireCuboid(minp, maxp);
		glLineWidth(1.0);
	}

	// p[eBN
	if(g_iDraw & RXD_PARTICLE){
		glEnable(GL_LIGHTING);
		RXREAL prad = (RXREAL)g_pSolver->GetParticleRadius();			// p[eBNa

		unsigned int pvbo = g_pSolver->GetCurrentReadBuffer();		// p[eBNSWVBO
		unsigned int cvbo = g_pSolver->GetColorBuffer();			// p[eBNJ[VBO
		DrawParticlePoints(pvbo, pnum, cvbo, 0, prad);
	}

	// t̕\ʃbV
	if((g_iDraw & RXD_SURF) && !g_Poly.vertices.empty()){
		glEnable(GL_LIGHTING);
		if(g_iDraw & RXD_SURF_EDGE){
			glColor3d(1.0, 1.0, 0.0);
		}
		else{
			glColor3d(1.0, 1.0, 1.0);
		}

		g_Poly.Draw((g_iDraw & RXD_SURF_EDGE ? 2 : 4), 0.1, false);
	}
	
	// ő̃IuWFNg
	if((g_iDraw & RXD_SOLID)){
		glDisable(GL_LIGHTING);
		glColor4d(0.0, 1.0, 0.0, 1.0);
		glLineWidth(1.0);
		g_pSolver->DrawObstacles();
	}

	// Z
	if((g_iDraw & RXD_CELLS)){
		glDisable(GL_LIGHTING);
		glLineWidth(1.0);
		g_pSolver->DrawCells(Vec3(0.0, 1.0, 0.0), Vec3(1.0, 0.0, 0.0));
	}

	glPopMatrix();

	glutSwapBuffers();
}


/*! 
 * TCYCxg֐
 * @param[in] w LoX(sNZ)
 * @param[in] h LoX(sNZ)
 */
void Resize(int w, int h)
{
	g_iWinW = w;
	g_iWinH = h;

	glViewport(0, 0, w, h);
	g_tbView.SetRegion(w, h);

	// ϊs̐ݒ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(RX_FOV, (float)g_iWinW/(float)g_iWinH, 0.1, 100.0);

	// fr[ϊs̐ݒ
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

/*!
 * }EXCxg֐
 * @param[in] button }EX{^(GLUT_LEFT_BUTTON,GLUT_MIDDLE_BUTTON,GLUT_RIGHT_BUTTON)
 * @param[in] state }EX{^̏(GLUT_UP, GLUT_DOWN)
 * @param[in] x,y }EXW(XN[Wn)
 */
void Mouse(int button, int state, int x, int y)
{
	if(x < 0 || y < 0 || x > g_iWinW || y > g_iWinH) return;

	int mod = glutGetModifiers();	// SHIFT,CTRL,ALT̏Ԏ擾

	if(button == GLUT_LEFT_BUTTON){
		if(state == GLUT_DOWN){
			g_tbView.Start(x, y, mod+1);
		}
		else if(state == GLUT_UP){
			g_tbView.Stop(x, y);
		}
	}

	glutPostRedisplay();
}

/*!
 * [VCxg֐(}EX{^܂܃hbO)
 * @param[in] x,y }EXW(XN[Wn)
 */
void Motion(int x, int y)
{
	if(x < 0 || y < 0 || x > g_iWinW || y > g_iWinH) return;
	
	g_tbView.Motion(x, y);

	glutPostRedisplay();
}


/*! 
 * AChCxg֐
 */
void Idle(void)
{
	if(g_pSolver){
		// V~[VXebvi߂
		g_pSolver->Update(g_fDt, g_iStep);

		// `ʂ̉摜o
		if(g_iSaveImageSpacing > 0 && (g_iStep%g_iSaveImageSpacing == 0)){
			SaveDisplay(CreateFileName("img/display_", ".bmp", g_iStep, 5));
		}

		// \ʃbV쐬Əo
		if(g_iDraw & RXD_SURF){
			CreateMesh();
		}

		// EBhE^CgXV
		SetTitle();
		
		g_iStep++;
		if(g_iStep > 10000) SwitchIdle(0);
		glutPostRedisplay();
	}
}

/*!
 * L[{[hCxg֐
 * @param[in] key L[̎
 * @param[in] x,y L[ꂽƂ̃}EXW(XN[Wn)
 */
void Keyboard(unsigned char key, int x, int y)
{
	switch(key){
	case 'q':
	case 'Q':
	case '\033':
		OnExitApp(0);
		break;

	case ' ':	// V~[V1Xebvi߂
		Idle();
		break;

	case 's':	// Aj[VON/OFF
		SwitchIdle(-1);
		break;

	case 'F':	// tXN[ON/OFF
		SwitchFullScreen();
		break;

	case 'b':	// E`
		g_iDraw ^= RXD_BOUNDARY;
		break;

	case 'm':	// t̕\ʃbV
		g_iDraw ^= RXD_SURF;
		if(g_iDraw & RXD_SURF) CreateMesh();
		break;

	case 'e':	// t̕\ʃbṼGbW`
		g_iDraw ^= RXD_SURF_EDGE;
		break;

	case 'p':	// p[eBN`
		g_iDraw ^= RXD_PARTICLE;
		break;

	case 'o':	// ő̃IuWFNg`
		g_iDraw ^= RXD_SOLID;
		break;

	case 'c':	// Z`
		g_iDraw ^= RXD_CELLS;
		break;

	default:
		break;
	}
	SetTitle();

	glutPostRedisplay();
}

/*!
 * L[{[hCxg֐
 * @param[in] key L[̎
 * @param[in] x,y L[ꂽƂ̃}EXW(XN[Wn)
 */
void SpecialKey(int key, int x, int y)
{
	// F1`F12ŃV[ݒǂݍ
	if(key >= GLUT_KEY_F1 && key <= GLUT_KEY_F12){
		if(g_Scene.SetCurrentScene(key-GLUT_KEY_F1)){
			g_iCurrentSceneIdx = g_Scene.GetCurrentSceneIdx();
			InitSim();
		}
	}
}

/*! 
 * GL̏֐
 */
void InitGL(void)
{
	RXCOUT << "OpenGL Ver. " << glGetString(GL_VERSION) << endl;
	glewInit();

	glClearColor(1.0, 1.0, 1.0, 1.0);
	glClearDepth(1.0f);

	glEnable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);

	glEnable(GL_AUTO_NORMAL);
	glEnable(GL_NORMALIZE);

	// ݒ
	static const GLfloat lpos[] = { 0.0f, 0.0f, 1.0f, 1.0f }; // ʒu
	static const GLfloat difw[] = { 0.7f, 0.7f, 0.7f, 1.0f }; // gUF : 
	static const GLfloat spec[] = { 0.2f, 0.2f, 0.2f, 1.0f }; // ʔːF
	static const GLfloat ambi[] = { 0.1f, 0.1f, 0.1f, 1.0f }; // 
	glLightfv(GL_LIGHT0, GL_POSITION, lpos);
	glLightfv(GL_LIGHT0, GL_DIFFUSE,  difw);
	glLightfv(GL_LIGHT0, GL_SPECULAR, spec);
	glLightfv(GL_LIGHT0, GL_AMBIENT,  ambi);
	glEnable(GL_LIGHT0);
	
	glEnable(GL_LIGHTING);
	glShadeModel(GL_SMOOTH);

	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	// gbN{[p
	g_tbView.SetScaling(-3.0);
	g_tbView.SetTranslation(0.0, 0.0);

	// GLSL̃RpC
	g_glslPointSprite = CreateGLSL(ps_vs, ps_fs, "point sprite");
}



/*! 
 * GL̏I֐
 */
void CleanGL(void)
{
	// ݒt@C
	WriteConfig(RX_PROGRAM_NAME);
	if(g_pINI != NULL) delete g_pINI;

	if(g_pSolver) delete g_pSolver;
}



/*!
 * Cj[
 * @param[in] id j[ID
 */
void OnMainMenu(int id)
{
	Keyboard((unsigned char)id, 0, 0);
}

/*!
 * GLUT̉ENbNj[쐬
 */
void InitMenu(void)
{
	// Cj[
	glutCreateMenu(OnMainMenu);
	glutAddMenuEntry("Toggle velocity drawing [v]",	'v');
	glutAddMenuEntry("Toggle boundary drawing [b]",	'b');
	glutAddMenuEntry("Toggle surface drawing [m]",	'm');
	glutAddMenuEntry("Toggle edge drawing [e]",		'e');
	glutAddMenuEntry("Toggle particle drawing [p]",	'p');
	glutAddMenuEntry("Toggle solid drawing [o]",	'o');
	glutAddMenuEntry("Toggle cell drawing [c]",		'c');
	glutAddMenuEntry("------------", -1);
	glutAddMenuEntry("Toggle Fullscreen [F]",		'F');
	glutAddMenuEntry("Toggle Animation [s]",		's');
	glutAddMenuEntry("Step Animation [ ]",			' ');
	glutAddMenuEntry("------------", -1);
	glutAddMenuEntry("Exit [q]",					'q');

	glutAddMenuEntry("Quit [ESC]", '\033');
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}



/*!
 * C[`
 * @param[in] argc R}hC̐
 * @param[in] argv R}hC
 */
int main(int argc, char *argv[])
{
	ReadConfig(RX_PROGRAM_NAME);

	MkDir("img");
	MkDir("mesh");

	// GLUTEBhE
	glutInit(&argc, argv);

	glutInitWindowPosition(g_iWinX, g_iWinY);
	glutInitWindowSize(g_iWinW, g_iWinH);

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow(argv[0]);

	glutDisplayFunc(Display);
	glutReshapeFunc(Resize);
	glutMouseFunc(Mouse);
	glutMotionFunc(Motion);
	glutKeyboardFunc(Keyboard);
	glutSpecialFunc(SpecialKey);

	SwitchIdle(0);

	InitGL();
	InitMenu();

	InitSim();

	glutMainLoop();

	CleanGL();

	return 0;
}


