/*!
  @file rx_sph_config.h
	
  @brief SPH̃V[ݒt@Cǂݍ
 
  @author Makoto Fujisawa
  @date 2012-08
*/
// FILE --rx_sph_config.h--

#ifndef _RX_SPH_CONFIG_H_
#define _RX_SPH_CONFIG_H_


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_common.h"

// V~[V
#include "rx_sph.h"

// ݒt@C
#include "rx_atom_ini.h"

using namespace std;


//-----------------------------------------------------------------------------
// 񏈗֐
//-----------------------------------------------------------------------------
/*!
 * "(x, y, z)"̌`̕񂩂Vec3^֕ϊ
 *  - (x)ƂȂĂ(x, x, x)ƂD
 * @param[in] s 
 * @param[out] v l
 * @return vfLq
 */
static inline int StringToVec3(const string &s, Vec3 &v)
{
	int vcount = 0;
	size_t pos;
	v = Vec3(0.0);
	if((pos = s.find('(')) != string::npos){
		while(pos != string::npos && vcount < 3){
			size_t pos1 = pos;
			if((pos1 = s.find(',', pos+1)) != string::npos){
				v[vcount] = atof(s.substr(pos+1, (pos1-(pos+1))).c_str());
				vcount++;
				pos = pos1;
			}
			else if((pos1 = s.find(')', pos+1)) != string::npos){
				v[vcount] = atof(s.substr(pos+1, (pos1-(pos+1))).c_str());
				vcount++;
				break;
			}
			else{
				break;
			}
		}
	}
	if(vcount < 3){
		for(int i = vcount; i < 3; ++i){
			v[i] = v[vcount-1];
		}
	}

	return vcount;
}

/*!
 * 񂩂l(Vec3)擾
 * @param[out] val l
 * @param[in] str 
 * @param[in] rel trueŃV~[VԂ̑傫ɑ΂WƂČvZ
 * @param[in] cen V~[VԂ̒SW
 * @param[in] ext V~[VԂ̑傫(eӂ̒1/2)
 */
inline void GetValueFromString(Vec3 &val, const string &str, bool rel = false, Vec3 cen = Vec3(0.0), Vec3 ext = Vec3(1.0))
{
	int n = StringToVec3(str, val);
	if(rel){
		val = cen+(n == 1 ? RXFunc::Min3(ext) : ext)*val;
	}
}

/*!
 * 񂩂l(double)擾
 * @param[out] val l
 * @param[in] str 
 * @param[in] rel trueŃV~[VԂ̑傫ɑ΂WƂČvZ
 * @param[in] cen V~[VԂ̒SW
 * @param[in] ext V~[VԂ̑傫(eӂ̒1/2)
 */
inline void GetValueFromString(double &val, const string &str, bool rel = false, Vec3 cen = Vec3(0.0), Vec3 ext = Vec3(1.0))
{
	val = atof(str.c_str());
	if(rel){
		val = RXFunc::Min3(ext)*val;
	}
}

/*!
 * t@C
 * @param head : {t@C
 * @param ext  : gq
 * @param n    : A
 * @param d    : AԌ
 * @return t@C
 */
static inline string CreateFileName(const string &head, const string &ext, int n, const int &d)
{
	string file_name = head;
	int dn = d-1;
	if(n > 0){
		dn = (int)(log10((double)n))+1;
	}
	else if(n == 0){
		dn = 1;
	}
	else{
		n = 0;
		dn = 1;
	}

	for(int i = 0; i < d-dn; ++i){
		file_name += "0";
	}

	file_name += RX_TO_STRING(n);
	if(!ext.empty() && ext[0] != '.') file_name += ".";
	file_name += ext;

	return file_name;
}

static inline int ExistFile(const char *fn)
{
	FILE *fp;
	if( (fp = fopen(fn, "r")) == NULL ){
		return 0;
	}
	fclose(fp);
	return 1;
}

//-----------------------------------------------------------------------------
//! rxSceneConfigNX - V[ݒt@Cǂݍ
//-----------------------------------------------------------------------------
class rxSceneConfig
{
protected:
	rxParticleSystemBase *m_pSolver;	//!< ̃\o
	rxEnviroment m_Env;					//!< ݒ
	
	string m_strCurrentScene;			//!< ݂̃V[̖O
	vector<string> m_vSceneFiles;		//!< V[t@CXg
	int m_iSceneFileNum;				//!< V[t@C̐

	vector<string> m_vSceneTitles;		//!< V[t@CXg
	int m_iCurrentSceneIdx;				//!< ݂̃V[t@C

public:
	//! ftHgRXgN^
	rxSceneConfig() : m_pSolver(0)
	{
		m_vSceneFiles.resize(12, "");	// V[t@CXg
		m_vSceneTitles.resize(12, "");	// V[^CgXg
		m_iCurrentSceneIdx = -1;		// ݂̃V[t@C
		m_strCurrentScene = "null";		// ݂̃V[̖O
		m_iSceneFileNum = 0;

		Clear();
	}

	//! fXgN^
	~rxSceneConfig(){}
	
	//! ݒ菉
	void Clear(void)
	{
		m_pSolver = 0;
	}


	//! V[^CgXg
	vector<string> GetSceneTitles(void) const { return m_vSceneTitles; }

	//! ݂̃V[
	int GetCurrentSceneIdx(void) const { return m_iCurrentSceneIdx; }

	//! V[̎擾
	rxEnviroment GetEnv(void) const { return m_Env; }

	//! \o[NX̐ݒ
	void Set(rxParticleSystemBase *x){ m_pSolver = x; }

public:
	/*!
	 * ݒ肩p[^̓ǂݍ
	 * @param[in] names ږXg
	 * @param[in] values lXg
	 * @param[in] n Xg̃TCY
	 * @param[in] header wb_
	 */
	static void SetSpace_s(string *names, string *values, int n, string header, void *x)
	{
		((rxSceneConfig*)x)->SetSpace(names, values, n, header);
	}
	void SetSpace(string *names, string *values, int n, string header)
	{
		rxEnviroment env;
		int idr = 0;
		for(int i = 0; i < n; ++i){
			if(names[i] == "cen")      GetValueFromString(env.boundary_cen, values[i], false);
			else if(names[i] == "ext") GetValueFromString(env.boundary_ext, values[i], false);
			else if(names[i] == "max_particle_num")  env.max_particles = atoi(values[i].c_str());
			else if(names[i] == "density")			 env.dens = atof(values[i].c_str());
			else if(names[i] == "mass")				 env.mass = atof(values[i].c_str());
			else if(names[i] == "kernel_particles")  env.kernel_particles = atof(values[i].c_str());
			else if(names[i] == "dt")				 env.dt = atof(values[i].c_str());
			else if(names[i] == "viscosity")		 env.viscosity = atof(values[i].c_str());
			else if(names[i] == "gas_stiffness")	 env.gas_k = atof(values[i].c_str());
			else if(names[i] == "mesh_res_max")		 env.mesh_max_n = atoi(values[i].c_str());
			else if(names[i] == "mesh_threshold")	 env.mesh_thr = atof(values[i].c_str());
		}
		m_Env = env;
	}

	//! t : `
	static void SetLiquidBox_s(string *names, string *values, int n, string header, void *x)
	{
		((rxSceneConfig*)x)->SetLiquidBox(names, values, n, header);
	}
	void SetLiquidBox(string *names, string *values, int n, string header)
	{
		bool rel = (header.find("(r)") != string::npos);
		Vec3 cen(0.0), ext(0.0), vel(0.0);
		for(int i = 0; i < n; ++i){
			if(names[i] == "cen")      GetValueFromString(cen, values[i], rel, m_pSolver->GetCen(), 0.5*m_pSolver->GetDim());
			else if(names[i] == "ext") GetValueFromString(ext, values[i], rel, Vec3(0.0), 0.5*m_pSolver->GetDim());
			else if(names[i] == "vel") GetValueFromString(vel, values[i], false);
		}
		m_pSolver->AddBox(-1, cen, ext, vel, 2*m_pSolver->GetParticleRadius());
		RXCOUT << "set liquid box : " << cen << ", " << ext << ", " << vel << endl;
	}

	//! t : 
	static void SetLiquidSphere_s(string *names, string *values, int n, string header, void *x)
	{
		((rxSceneConfig*)x)->SetLiquidSphere(names, values, n, header);
	}
	void SetLiquidSphere(string *names, string *values, int n, string header)
	{
		bool rel = (header.find("(r)") != string::npos);
		Vec3 cen(0.0), vel(0.0);
		double rad = 0.0;
		for(int i = 0; i < n; ++i){
			if(names[i] == "cen")      GetValueFromString(cen, values[i], rel, m_pSolver->GetCen(), 0.5*m_pSolver->GetDim());
			else if(names[i] == "rad") GetValueFromString(rad, values[i], rel, Vec3(0.0), 0.5*m_pSolver->GetDim());
			else if(names[i] == "vel") GetValueFromString(vel, values[i], false);
		}
		RXCOUT << "set liquid sphere : " << cen << ", " << rad << endl;
	}

	//! ő : `
	static void SetSolidBox_s(string *names, string *values, int n, string header, void *x)
	{
		((rxSceneConfig*)x)->SetSolidBox(names, values, n, header);
	}
	void SetSolidBox(string *names, string *values, int n, string header)
	{
		bool rel = (header.find("(r)") != string::npos);
		Vec3 cen(0.0), ext(0.0), ang(0.0), vel(0.0);
		for(int i = 0; i < n; ++i){
			if(names[i] == "cen")      GetValueFromString(cen, values[i], rel, m_pSolver->GetCen(), 0.5*m_pSolver->GetDim());
			else if(names[i] == "ext") GetValueFromString(ext, values[i], rel, Vec3(0.0), 0.5*m_pSolver->GetDim());
			else if(names[i] == "ang") GetValueFromString(ang, values[i], false);
			else if(names[i] == "vel") GetValueFromString(vel, values[i], false);
		}
		m_pSolver->SetBoxObstacle(cen, ext, ang, vel, 1);
		RXCOUT << "set solid box : " << cen << ", " << ext << ", " << ang << endl;
	}

	//! ő : 
	static void SetSolidSphere_s(string *names, string *values, int n, string header, void *x)
	{
		((rxSceneConfig*)x)->SetSolidSphere(names, values, n, header);
	}
	void SetSolidSphere(string *names, string *values, int n, string header)
	{
		bool rel = (header.find("(r)") != string::npos);
		Vec3 cen(0.0), vel(0.0);
		double rad = 0.0;
		for(int i = 0; i < n; ++i){
			if(names[i] == "cen")      GetValueFromString(cen, values[i], rel, m_pSolver->GetCen(), 0.5*m_pSolver->GetDim());
			else if(names[i] == "rad") GetValueFromString(rad, values[i], rel, Vec3(0.0), 0.5*m_pSolver->GetDim());
			else if(names[i] == "vel")  GetValueFromString(vel, values[i], false);
		}
		m_pSolver->SetSphereObstacle(cen, rad, vel, 1);
		RXCOUT << "set solid sphere : " << cen << ", " << rad << endl;
	}

	/*!
	 * V~[VԂ̐ݒǂݍ
	 */
	bool LoadSpaceFromFile(void)
	{
		bool ok = true;
		rxINI *cfg = new rxINI();
		cfg->SetHeaderFunc("space", &rxSceneConfig::SetSpace_s, this);
		if(!(cfg->Load(m_strCurrentScene))){
			RXCOUT << "Failed to open the " << m_strCurrentScene << " file!" << endl;
			ok = false;
		}
		delete cfg;
		return ok;
	}
	
	/*!
	 * p[eBNő̃IuWFNg̐ݒǂݍ
	 */
	bool LoadSceneFromFile(void)
	{
		bool ok = true;
		rxINI *cfg = new rxINI();
		cfg->SetHeaderFunc("liquid box",		&rxSceneConfig::SetLiquidBox_s, this);
		cfg->SetHeaderFunc("liquid box (r)",    &rxSceneConfig::SetLiquidBox_s, this);
		cfg->SetHeaderFunc("liquid sphere",		&rxSceneConfig::SetLiquidSphere_s, this);
		cfg->SetHeaderFunc("liquid sphere (r)", &rxSceneConfig::SetLiquidSphere_s, this);
		cfg->SetHeaderFunc("solid box",			&rxSceneConfig::SetSolidBox_s, this);
		cfg->SetHeaderFunc("solid box (r)",		&rxSceneConfig::SetSolidBox_s, this);
		cfg->SetHeaderFunc("solid sphere",		&rxSceneConfig::SetSolidSphere_s, this);
		cfg->SetHeaderFunc("solid sphere (r)",	&rxSceneConfig::SetSolidSphere_s, this);
		if(!(cfg->Load(m_strCurrentScene))){
			RXCOUT << "Failed to open the " << m_strCurrentScene << " file!" << endl;
			ok = false;
		}
		delete cfg;
		return ok;
	}

	/*!
	 * w肵tH_ɂݒt@C̐ƃV[^Cgǂݎ
	 * @param[in] dir ݒt@CtH_(w肵ȂΎstH_)
	 */
	void ReadSceneFiles(string dir = "")
	{
		m_vSceneFiles.resize(12, "");	// V[t@CXg
		m_vSceneTitles.resize(12, "");	// V[^CgXg

		ifstream scene_ifs;
		string scene_fn = "null";
		for(int i = 1; i <= 12; ++i){
			if(ExistFile((scene_fn = CreateFileName(dir+"sph_scene_", ".cfg", i, 1)).c_str())){
				RXCOUT << "scene " << i << " : " << scene_fn << endl;
				m_vSceneFiles[i-1] = scene_fn;
				m_vSceneTitles[i-1] = scene_fn.substr(0, 11);

				// V[^Cg̓ǂݎ
				scene_ifs.open(scene_fn.c_str(), ios::in);
				string title_buf;
				getline(scene_ifs, title_buf);
				if(!title_buf.empty() && title_buf[0] == '#'){
					m_vSceneTitles[i-1] = title_buf.substr(2, title_buf.size()-2);
				}
				scene_ifs.close();

				m_iSceneFileNum++;
			}
		}

		if(m_iSceneFileNum){
			SetCurrentScene(0);
		}
	}

	/*!
	 * Jg̃V[ݒ
	 * @param[in] V[CfbNX
	 */
	bool SetCurrentScene(int idx)
	{
		if(idx < 0 || idx >= m_iSceneFileNum || m_vSceneFiles[idx] == ""){
			cout << "There is no scene files!" << endl;
			return false;
		}
		m_iCurrentSceneIdx = idx;
		m_strCurrentScene = m_vSceneFiles[m_iCurrentSceneIdx];
		return true;
	}

	/*!
	 * ^CgJg̃V[ݒ
	 * @param[in] label V[^Cg
	 */
	bool SetCurrentSceneFromTitle(const string label)
	{
		int scene = 0;
		while(label.find(m_vSceneTitles[scene]) == string::npos) scene++;

		if(m_iCurrentSceneIdx != -1 && m_vSceneFiles[scene] != ""){
			RXCOUT << "scene " << scene+1 << " : " << m_vSceneFiles[scene] << endl;
			m_iCurrentSceneIdx = scene;
			m_strCurrentScene = m_vSceneFiles[scene];
			return true;
		}

		return false;
	}


	vector<string> GetSceneTitleList(void){ return m_vSceneTitles; }
};


#endif // #ifndef _RX_SPH_CONFIG_H_