/*!
  @file rx_volume_renderer.h
	
  @brief XCXp{[_O
 
  @author Makoto Fujisawa
  @date 2012-12
*/

#ifndef _RX_VOLUME_RENDERER_H_
#define _RX_VOLUME_RENDERER_H_


//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "rx_shaders.h"
#include "rx_utility.h"
#include "rx_matrix.h"

#include "rx_common.h"

//-----------------------------------------------------------------------------
// `
//-----------------------------------------------------------------------------
#ifndef RXREAL
#define RXREAL float
#endif


//-----------------------------------------------------------------------------
// rxVolumeRendererNX̐錾
//-----------------------------------------------------------------------------
class rxVolumeRenderer
{
protected:
	GLuint m_uVolumeTex;		//!< {[f[^i[eNX`
	int m_iNx, m_iNy, m_iNz;	//!< {[f[^̃TCY

	double m_fNear, m_fFar;		//!< ONbv
	int m_iNumLayers;			//!< XCX̐

	int m_iShaderInit;			//!< VF[_tO
	rxGLSL m_glslVolume;		//!< GLSLVF[_
	
	double m_fOpacity;			//!< sx
	Vec3 m_v3DensColor;			//!< {[̐F

public:
	//! ftHgRXgN^
	rxVolumeRenderer(double near, double far, int num_layer);

	//! fXgN^
	~rxVolumeRenderer();

	//! {[f[^̃Zbg
	int SetVolumeData(unsigned char *data, int nx, int ny, int nz);
	int SetVolumeDataf(RXREAL *data, int nx, int ny, int nz, Vec3 col);

	//! {[f[^̃_O
	void Draw(void);


protected:
	//! GLSLVF[_̏
	void initShaders(void);

	//! OpenGLfr[s񂩂`͈͂vZ
	void calBBox(Vec3 &minp, Vec3 &maxp);
};



#endif	// _RX_VOLUME_RENDERER_H_

